SystemOrganization addCategory: #'Manifest-Core'!

!RBToDoRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBToDoRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ToDoRule'! !

!RBToDoRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:33'!
category 
	^ 'Coding Idiom Violation'! !

!RBGuardClauseRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBGuardClauseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'GuardClauseRule'! !

!RBGuardClauseRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:50'!
category 
	^ 'Coding Idiom Violation'! !

!RBLiteralArrayContainsSuspiciousTrueFalseOrNilRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLiteralArrayContainsSuspiciousTrueFalseOrNilRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'LiteralArrayContainsSuspiciousTrueFalseOrNilRule'! !

!RBLiteralArrayContainsSuspiciousTrueFalseOrNilRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 14:12'!
category
	^ 'Potential Bugs'! !

!RBLiteralArrayContainsSuspiciousTrueFalseOrNilRule methodsFor: '*Manifest-Core' stamp: 'StephaneDucasse 12/30/2012 20:56'!
longDescription
	^ 'Some times ago, arrays were not allowed to contain true false and nil objects. They only contain their symbol representation: evaluating #(true false nil) returns #(#true #false #nil). 
	Nowadays, #(true false nil) is equivalent to {true . false . nil }, i.e., it returns an array with the objects true, false, and nil. 
	This smells checks methods having #(#true #false #nil) in their literal frame since it can be the source of potential bugs. 
	 '! !

!RBAddRemoveDependentsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAddRemoveDependentsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'AddRemoveDependentsRule'! !

!RBAddRemoveDependentsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 14:11'!
category 
	^ 'Potential Bugs'! !

!RBFileBlocksRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBFileBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'FileBlocksRule'! !

!RBFileBlocksRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:29'!
category
	^'Potential Bugs'! !

!RBLiteralValuesSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'LiteralValuesSpellingRule'! !

!RBUnreferencedVariablesRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnreferencedVariablesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnreferencedVariablesRule'! !

!RBUnreferencedVariablesRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:44'!
category
	^ 'Design Flaws'! !

!RBArgumentVariableNamesSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ArgumentVariableNamesSpellingRule'! !

!RBUnwindBlocksRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnwindBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnwindBlocksRule'! !

!RBUnwindBlocksRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:54'!
category
	^ 'Optimization'! !

!RBInstanceVariableNamesSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'InstanceVariableNamesSpellingRule'! !

!RBYourselfNotUsedRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBYourselfNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'YourselfNotUsedRule'! !

!RBYourselfNotUsedRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:36'!
category 
	^ 'Optimization'! !

!RBBrowserEnvironment methodsFor: '*manifest-core' stamp: 'SimonAllier 3/30/2012 11:42'!
isMultiEnvironment
	^ false! !

!RBToDoCollectRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBToDoCollectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ToDoCollectRule'! !

!RBToDoCollectRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:33'!
category 
	^ 'Coding Idiom Violation'! !

!RBCollectSelectNotUsedRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCollectSelectNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'CollectSelectNotUsedRule'! !

!RBCollectSelectNotUsedRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:24'!
category 	
	^ 'Optimization'! !

!RBReturnsIfTrueRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBReturnsIfTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ReturnsIfTrueRule'! !

!RBReturnsIfTrueRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:27'!
category 
	^ 'Potential Bugs'! !

!RBSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SpellingRule'! !

!RBSpellingRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 11:24'!
category 	
	^ 'Spelling'! !

!RBUnnecessaryAssignmentRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnnecessaryAssignmentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnnecessaryAssignmentRule'! !

!RBUnnecessaryAssignmentRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:34'!
category 
	^ 'Optimization'! !

!RBCodeCruftLeftInMethodsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCodeCruftLeftInMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'CodeCruftLeftInMethodsRule'! !

!RBCodeCruftLeftInMethodsRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:49'!
category 
	^ 'Bugs'! !

!RBCodeCruftLeftInMethodsRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:47'!
longDescription 
	^ 'This smell arises when a breakpoints, logging statements, etc is found in a method. This debugging code should not be left in production code.'! !

!RBTranslateLiteralsInMenusRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTranslateLiteralsInMenusRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'TranslateLiteralsInMenusRule'! !

!RBTranslateLiteralsInMenusRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 11:22'!
category 
	^ 'Potential Bugs'! !

!RBImplementedNotSentRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBImplementedNotSentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ImplementedNotSentRule'! !

!RBImplementedNotSentRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:13'!
category
	^ 'Design Flaws'! !

!RBImplementedNotSentRule methodsFor: '*Manifest-Core' stamp: 'StephaneDucasse 12/30/2012 20:38'!
longDescription

	^ 'This smell arises when a method is implemented but never sent. If a method is not sent, it can be removed. This rule pays attention not to identify as unsent methods, methods with pragmas and test methods since they are likely to be sent through reflection.
	Now if your code is used and extended by others better use a deprecation mechanism. To define a deprecate method follow the pattern: 
	
	foo
		self deprecated: ''Use bar instead ''. 
		^ self bar
		 
'! !

!RBInstVarInSubclassesRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBInstVarInSubclassesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'InstVarInSubclassesRule'! !

!RBInstVarInSubclassesRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:21'!
category
	^ 'Design Flaws'! !

!RBInstVarInSubclassesRule methodsFor: '*Manifest-Core' stamp: 'StephaneDucasse 12/30/2012 20:44'!
longDescription

	^ 'This smell arises when instance variables are defined in all subclasses. Many times you might want to pull the instance variable up into the class so that all the subclasses do not have to define it. In addition have a look at the initialize method in each of the subclasses because if the instance variable is really the same, it will be initialized similarly in different places.'! !

!RBRefersToClassRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBRefersToClassRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'RefersToClassRule'! !

!RBRefersToClassRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:35'!
category 
	^ 'Design Flaws'! !

!RBRefersToClassRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 13:09'!
longDescription

	^ 'This smell arises when a class has its class name directly in the source instead of "self class". The self class variant allows you to create subclasses without needing to redefine that method.'! !

!RBMethodHasNoTimeStampRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodHasNoTimeStampRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MethodHasNoTimeStampRule'! !

!RBMethodHasNoTimeStampRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:24'!
category
	^ 'Bugs' ! !

!RBGuardingClauseRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBGuardingClauseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'GuardingClauseRule'! !

!RBGuardingClauseRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:31'!
category 
	^ 'Coding Idiom Violation'! !

!Behavior methodsFor: '*Manifest-Core' stamp: 'SimonAllier 5/29/2012 10:36'!
isManifest

	^ self name beginsWith: 'Manifest'! !

!RBMethodProtocolsSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MethodProtocolsSpellingRule'! !

!RBMissingTranslationsInMenusRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMissingTranslationsInMenusRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MissingTranslationsInMenusRule'! !

!RBInconsistentMethodClassificationRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBInconsistentMethodClassificationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'InconsistentMethodClassificationRule'! !

!RBInconsistentMethodClassificationRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:14'!
category
	^ 'Design Flaws'! !

!RBInconsistentMethodClassificationRule methodsFor: '*Manifest-Core' stamp: 'StephaneDucasse 12/30/2012 20:40'!
longDescription

	^ 'This smell arises when a method protocol is not equivalent to the one defined in the superclass of such method class. All methods should be put into a protocol (method category) that is equivalent to the one of the superclass, which is a standart style in Smalltalk. Furthermore, methods which are extended in the superclass are ignored, since they may have different protocol name. Pay attention when you apply automatic recategorisation because it may move method in antoher package if the method is defined in the superclass as an extension.'! !

!RBInstanceVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBInstanceVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'InstanceVariableCapitalizationRule'! !

!RBInstanceVariableCapitalizationRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:14'!
category
	^ 'Style'! !

!RBInstanceVariableCapitalizationRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 15:07'!
longDescription

	^ 'This smell arises when instance variable names (in instance and class side) do not start with an lowercase letter, which is a standart style in Smalltalk.'! !

!RBModifiesCollectionRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBModifiesCollectionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ModifiesCollectionRule'! !

!RBModifiesCollectionRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:25'!
category
	^ 'Potential Bugs'! !

!RBNoClassCommentRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBNoClassCommentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'NoClassCommentRule'! !

!RBNoClassCommentRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:32'!
category 
	^ 'Coding Idiom Violation'! !

!RBNoClassCommentRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 12:16'!
longDescription

	^ 'This smell arises when a class has no comment. Classes should have comments to explain their purpose, collaborations with other classes, and optionally provide examples of use.'! !

!RBUsesAddRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUsesAddRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UsesAddRule'! !

!RBUsesAddRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:35'!
category 
	^ 'Potential Bugs'! !

!RBWhileTrueRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBWhileTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'WhileTrueRule'! !

!RBWhileTrueRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:36'!
category 
	^ 'Coding Idiom Violation'! !

RBSmalllintChecker subclass: #SmalllintManifestChecker
	instanceVariableNames: 'manifestClassCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!SmalllintManifestChecker methodsFor: 'manifest' stamp: 'SimonAllier 2/1/2013 15:06'!
cleanAllManifest
	|manifests|
	
	manifests := environment packages collect: [:cl |
		BuilderManifest of: cl] as: Set.
	
	manifests do: [:each |
		each cleanUp]! !

!SmalllintManifestChecker methodsFor: 'accessing' stamp: 'SimonAllier 2/8/2013 16:34'!
criticsOf: aRule
	| rules |
	
	rules := rule leaves detect: [:r |
		r class = aRule class] ifNone: [^{}].
	
	^ rules critics! !

!SmalllintManifestChecker methodsFor: 'manifest' stamp: 'SimonAllier 2/1/2013 12:50'!
falsePositiveOf: aRule
	
	|critics rId rV  mb |
	
	critics := self criticsOf: aRule. 
	
	rId := aRule class uniqueIdentifierName.
	rV := aRule class identifierMinorVersionNumber.

	^ critics select: [:critic |mb := (self manifestBuilderOf: critic).
		mb isNil 
			ifTrue: [false] 
			ifFalse:[ mb isFalsePositive: critic onRule:  rId version: rV]]
	! !

!SmalllintManifestChecker methodsFor: 'initialize-release' stamp: 'SimonAllier 1/30/2013 11:39'!
initialize
	super initialize.
	manifestClassCache := Dictionary new.
! !

!SmalllintManifestChecker methodsFor: 'manifest' stamp: 'SimonAllier 1/25/2013 16:32'!
isFalsePositive: aCritic forRuleId: ruleId versionId: versionId 
| mb |
	mb := self manifestBuilderOf: aCritic.
	
	^  mb isNil 
		ifTrue: [false] 
		ifFalse: [ mb isFalsePositive:  aCritic onRule:  ruleId version: versionId]
! !

!SmalllintManifestChecker methodsFor: 'manifest' stamp: 'SimonAllier 1/25/2013 16:32'!
isToDo: aCritic forRuleId: ruleId versionId: versionId 
	
	| mb |
	mb := self manifestBuilderOf: aCritic.
	
	^  mb isNil 
		ifTrue: [false] 
		ifFalse: [ mb containsToDo: aCritic onRule:  ruleId version: versionId]
! !

!SmalllintManifestChecker methodsFor: 'manifest' stamp: 'SimonAllier 3/29/2012 13:01'!
isTruePositive: aCritic forRuleId: ruleId versionId: versionId 
	
	^  (self manifestBuilderOf: aCritic)
		containsTruePositive: aCritic onRule:  ruleId version: versionId
! !

!SmalllintManifestChecker methodsFor: 'accessing' stamp: 'SimonAllier 1/30/2013 15:32'!
manifestBuilderOf: aCritic
	 (aCritic class = MCWorkingCopy)
		ifTrue: [^ self manifestBuilderOfPackage:aCritic ]. 
	^ aCritic isCompiledMethod 
		ifTrue: [self manifestBuilderOfMethod: aCritic]
		ifFalse: [self manifestBuilderOfClass: aCritic]! !

!SmalllintManifestChecker methodsFor: 'accessing' stamp: 'SimonAllier 2/1/2013 15:21'!
manifestBuilderOfClass: aClass
	| key |
	key := aClass theNonMetaClass category.
	^ manifestClassCache
		at: key
		ifAbsentPut: [ 
			(BuilderManifest hasManifestFor: aClass)
				ifTrue: [ BuilderManifest of: aClass ]
				ifFalse: [ nil ] ]! !

!SmalllintManifestChecker methodsFor: 'accessing' stamp: 'SimonAllier 2/1/2013 15:27'!
manifestBuilderOfMethod: aMethod
	| key cl |
	cl := aMethod methodClass.
	key := cl name , aMethod category asString.
	^ manifestClassCache
		at: key
		ifAbsentPut: [ 
			(BuilderManifest hasManifestFor: aMethod)
				ifTrue: [ BuilderManifest of: aMethod ]
				ifFalse: [ nil ] ]! !

!SmalllintManifestChecker methodsFor: 'accessing' stamp: 'SimonAllier 2/1/2013 15:34'!
manifestBuilderOfPackage: aPackage
	| key |
	key := aPackage packageName.
	^ manifestClassCache
		at: key
		ifAbsentPut: [ 
			(BuilderManifest hasPackageNamed: key)
				ifTrue: [ BuilderManifest ofPackageNamed: key ]
				ifFalse: [ nil ] ]! !

!SmalllintManifestChecker methodsFor: 'manifest' stamp: 'SimonAllier 1/25/2013 16:34'!
rejectClassesOf: aPackage
		
	| mb |
	mb := self manifestBuilderOf: aPackage.
	
	^  mb isNil 
		ifTrue: [{}] 
		ifFalse: [ mb rejectClasses]
! !

!SmalllintManifestChecker methodsFor: 'manifest' stamp: 'SimonAllier 1/30/2013 11:17'!
rejectRulesOf: aPackage
		
	| mb |
	
	mb := self manifestBuilderOf: aPackage.
	
	^  mb isNil 
		ifTrue: [{}] 
		ifFalse: [ mb rejectRules]
	! !

!SmalllintManifestChecker methodsFor: 'accessing' stamp: 'SimonAllier 1/23/2013 17:12'!
rule
	^ rule! !

!SmalllintManifestChecker methodsFor: 'run' stamp: 'SimonAllier 1/22/2013 13:53'!
runRules: aCompositeRule onPackage: aPackage


	rule := aCompositeRule.
	environment := (RBPackageEnvironment new packages: {aPackage}).

	environment classesDo: [ :class |
		(class isTrait or: [class isManifest]) ifFalse: [
			self checkClass: class.
			self checkMethodsForClass: class ] ]! !

!SmalllintManifestChecker methodsFor: 'run' stamp: 'SimonAllier 1/22/2013 14:24'!
runRules: aCompositeRule onPackage: aPackage withoutTestCase: aBoolean


	rule := aCompositeRule.
	environment := (RBPackageEnvironment new packages: {aPackage}).

	environment classesDo: [ :class |
		(class isTrait or: [class isManifest
			or:[aBoolean and: [class allSuperclasses includes: TestCase ]]]) 
				ifFalse: [
					self checkClass: class.
					self checkMethodsForClass: class ] ]! !

!SmalllintManifestChecker methodsFor: 'manifest' stamp: 'SimonAllier 1/25/2013 16:40'!
toDoOf: aRule
	
	|critics rId rV mb |
	
	critics := self criticsOf: aRule. 
	
	rId := aRule class uniqueIdentifierName.
	rV := aRule class identifierMinorVersionNumber.
	
	^ critics select: [:critic |
		mb := (self manifestBuilderOf: critic).
		mb isNil 
			ifTrue: [false] 
			ifFalse:[ mb containsToDo: critic onRule:  rId version: rV]]
	
	! !

!RBExcessiveInheritanceRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExcessiveInheritanceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ExcessiveInheritanceRule'! !

!RBExcessiveInheritanceRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:06'!
category
	^ 'Design Flaws'! !

!RBExcessiveInheritanceRule methodsFor: '*Manifest-Core' stamp: 'ah 8/2/2012 13:48'!
longDescription

	^ 'This smell arises when a deep inheritance is found (depth of ten or more), which is usually a sign of a design flaw. It should be broken down and reduced to something manageable. The defined inheritance depth can be edited in RBExcessiveInheritanceRule>>inheritanceDepth.'! !

!RBCollectionCopyEmptyRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCollectionCopyEmptyRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'CollectionCopyEmptyRule'! !

!RBCollectionCopyEmptyRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:04'!
category 
	^ 'Potential Bugs'! !

!RBLawOfDemeterRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLawOfDemeterRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'LawOfDemeterRule'! !

!RBLawOfDemeterRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:21'!
category 	
	^ 'Design Flaws'! !

!RBClassVariableNamesSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ClassVariableNamesSpellingRule'! !

!RBClassNotReferencedRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBClassNotReferencedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ClassNotReferencedRule'! !

!RBClassNotReferencedRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:02'!
category 
	^ 'Design Flaws'! !

!RBClassNotReferencedRule methodsFor: '*Manifest-Core' stamp: 'ah 8/2/2012 13:06'!
longDescription

	^ 'This smell arises when a class is not referenced either directly or indirectly by a symbol. If a class is not referenced, it can be removed.'! !

!RBEmptyExceptionHandlerRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEmptyExceptionHandlerRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'EmptyExceptionHandlerRule'! !

!RBEmptyExceptionHandlerRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:25'!
category
	^'Potential Bugs'! !

!RBMissingSuperSendsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMissingSuperSendsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MissingSuperSendsRule'! !

!RBMissingSuperSendsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:29'!
category 
	^ 'Potential Bugs'! !

!RBSearchingLiteralRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSearchingLiteralRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SearchingLiteralRule'! !

!RBSearchingLiteralRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:28'!
category 
	^ 'Optimization'! !

!RBSubclassResponsibilityNotDefinedRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSubclassResponsibilityNotDefinedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SubclassResponsibilityNotDefinedRule'! !

!RBSubclassResponsibilityNotDefinedRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:12'!
category 	
	
	^ 'Bugs'! !

!RBSubclassResponsibilityNotDefinedRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:11'!
longDescription

	^  'This rule checks if all subclassResponsibility methods are defined in all leaf classes. if such a method is not overridden, a subclassResponsibility message can be occur when this method is called'
! !

!RBMethodSelectorsSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MethodSelectorsSpellingRule'! !

!RBPlatformDependentUserInteractionRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBPlatformDependentUserInteractionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'PlatformDependentUserInteractionRule'! !

!RBPlatformDependentUserInteractionRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:26'!
category 
	^ 'Potential Bugs'! !

!RBExcessiveArgumentsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExcessiveArgumentsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ExcessiveArgumentsRule'! !

!RBExcessiveArgumentsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:06'!
category
	^ 'Design Flaws'! !

!RBExcessiveArgumentsRule methodsFor: '*Manifest-Core' stamp: 'ah 8/2/2012 13:42'!
longDescription

	^ 'This smell arises when a method contains a long number of argument (five or more), which can indicate that a new object should be created to wrap the numerous parameters. The defined number of arguments can be edited in RBExcessiveArgumentsRule>>argumentsCount.'! !

!RBTempsReadBeforeWrittenRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTempsReadBeforeWrittenRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'TempsReadBeforeWrittenRule'! !

!RBTempsReadBeforeWrittenRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:40'!
category
	^ 'Potential Bugs'! !

!RBBetweenAndRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBetweenAndRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'BetweenAndRule'! !

!RBBetweenAndRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:49'!
category 
	^ 'Coding Idiom Violation'! !

!RBBetweenAndRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 14:40'!
longDescription 
	^ ' Replaces "a >= b and: [a <= c]" by "a between: b and: c"'! !

!RBUncommonMessageSendRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUncommonMessageSendRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UncommonMessageSendRule'! !

!RBUncommonMessageSendRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:41'!
category
	^ 'Potential Bugs'! !

!RBBooleanPrecedenceRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBooleanPrecedenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'BooleanPrecedenceRule'! !

!RBBooleanPrecedenceRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:21'!
category 
	^ 'Potential Bugs'! !

!RBEndTrueFalseRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEndTrueFalseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'EndTrueFalseRule'! !

!RBEndTrueFalseRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:25'!
category
	^'Optimization'! !

!RBEndTrueFalseRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 13:10'!
longDescription 
	^ 'Checks for ifTrue:ifFalse: blocks that have the same code at the beginning or end. While you might not originally write such code, as it is modified, it is easier to create such code. Instead of having the same code in two places, you should move it outside the blocks.
For example, 
test 
	ifTrue:[self foo. self bar] 
	ifFalse: [self foo. self baz]
 is equivalent to: 
self foo.  
test 
	ifTrue:[self bar] 
	ifFalse: [self baz]'! !

!RBFloatEqualityComparisonRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBFloatEqualityComparisonRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'FloatEqualityComparisonRule'! !

!RBFloatEqualityComparisonRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 13:58'!
category 
	^ 'Potential Bugs'! !

!RBEqualNotUsedRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEqualNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'EqualNotUsedRule'! !

!RBEqualNotUsedRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:27'!
category
	^'Potential Bugs'! !

!RBPrecedenceRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBPrecedenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'PrecedenceRule'! !

!RBPrecedenceRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:27'!
category 
	^ 'Potential Bugs'! !

!RBToDoWithIncrementRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBToDoWithIncrementRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ToDoWithIncrementRule'! !

!RBToDoWithIncrementRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:33'!
category 
	^ 'Coding Idiom Violation'! !

!RGMethodDefinition class methodsFor: '*manifest-core' stamp: ''!
className: aString selector: aSelector isMetaSide: aBoolean

	^ (self class: (RGClassDefinition named: aString) selector: aSelector) isMetaSide: aBoolean; yourself! !

!RGMethodDefinition class methodsFor: '*manifest-core' stamp: 'SimonAllier 7/26/2012 15:32'!
manifestReadOn: aArray

 	^ self className:  (aArray at: 1) 
		selector: (aArray at: 2)
		isMetaSide: ((aArray at: 3) = #true)   
		! !

!RGMethodDefinition methodsFor: '*Manifest-Core' stamp: 'SimonAllier 7/26/2012 15:27'!
arrayStringForManifest
	|array|
	
	array := Array new:2.
	
	array at: 1 put:  (self class asString asSymbol).
	array at: 2 put: {self parentName asSymbol.  self selector asSymbol. self isMetaSide asString  asSymbol}.
	
	^ array 
	 ! !

!RGMethodDefinition methodsFor: '*Manifest-Core' stamp: ''!
storeOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: self class asString.
	aStream nextPutAll: ' className: '''.
	aStream nextPutAll: self parentName.
	
	aStream nextPutAll: ''' selector: '.
	aStream nextPutAll: self selector printString.
	
	aStream nextPutAll: ' isMetaSide: '.
	aStream nextPutAll: self isMetaSide printString.
	 aStream nextPut: $).! !

!RBUndeclaredReferenceRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUndeclaredReferenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UndeclaredReferenceRule'! !

!RBUndeclaredReferenceRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:42'!
category 
	^ 'Bugs'! !

!RBCollectionProtocolRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCollectionProtocolRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'CollectionProtocolRule'! !

!RBCollectionProtocolRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:22'!
category
	^'Coding Idiom Violation'! !

!RBDetectIfNoneRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBDetectIfNoneRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'DetectIfNoneRule'! !

!RBDetectIfNoneRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:50'!
category 
	^ 'Coding Idiom Violation'! !

!RBDetectIfNoneRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 14:38'!
longDescription 
	^ 'Replaces detect:ifNone: by anySatisfy:'! !

!RBExtraBlockRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExtraBlockRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ExtraBlockRule'! !

!RBExtraBlockRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:28'!
category
	^'Optimization'! !

!RBExtraBlockRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 11:41'!
longDescription 
 ^'Check for blocks that are immediately evaluated. Since the block is immediately evaluated, there is no need for the statements to be in a block.
For example, [:x | 1 + x] value: 4 is equivalent to 1 + 4'! !

!RBAllAnyNoneSatisfyRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAllAnyNoneSatisfyRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'AllAnyNoneSatisfyRule'! !

!RBAllAnyNoneSatisfyRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:47'!
category 
	^ 'Coding Idiom Violation'! !

!RBMinMaxRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMinMaxRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MinMaxRule'! !

!RBMinMaxRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:51'!
category 
	^ 'Coding Idiom Violation'! !

!RBClassCategoriesSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ClassCategoriesSpellingRule'! !

!RBParseTreeLintRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBParseTreeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ParseTreeLintRule'! !

!RBMethodModifierOverrideRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodModifierOverrideRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MethodModifierOverrideRule'! !

!RBClassNamesSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ClassNamesSpellingRule'! !

!RBAtIfAbsentRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAtIfAbsentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'AtIfAbsentRule'! !

!RBAtIfAbsentRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:48'!
category 
	^ 'Coding Idiom Violation'! !

!RBAtIfAbsentRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 14:40'!
longDescription 
		^ ' Replaces at:ifAbsent: by at:ifAbsentPut:'! !

!RBEquivalentSuperclassMethodsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEquivalentSuperclassMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'EquivalentSuperclassMethodsRule'! !

!RBEquivalentSuperclassMethodsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 11:22'!
category 	
	^ 'Design Flaws'! !

!RBEquivalentSuperclassMethodsRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 10:49'!
longDescription

	^ 'This smell arises when a method is equivalent to its superclass method. The methods are equivalent when they have the same abstract syntax tree, except for variables names. Such method does not add anything to the computation and can be removed since the superclass method have the same behaviour. Furthermore, the methods #new and #initialize are ignored once they are often overridden for compatilbity with other platforms. The ignored methods can be edited in RBEquivalentSuperclassMethodsRule>>ignoredSelectors'! !

!RBBlockLintRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBlockLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'BlockLintRule'! !

!RBSuperSendsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSuperSendsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SuperSendsRule'! !

!RBSuperSendsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:52'!
category 
	^ 'Design Flaws'! !

RBTransformationRule subclass: #RBRemoveAssignmentWithoutEffectRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!RBRemoveAssignmentWithoutEffectRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 14:05'!
category 
	^ 'Optimization'! !

!RBRemoveAssignmentWithoutEffectRule methodsFor: 'accessing' stamp: 'SimonAllier 9/5/2012 14:24'!
group
	^ 'Transformations'! !

!RBRemoveAssignmentWithoutEffectRule methodsFor: 'initialization' stamp: 'SimonAllier 2/8/2013 16:43'!
initialize
	super initialize.
 
	self rewriteRule
		replace: 	'`var := `var' with: ''! !

!RBRemoveAssignmentWithoutEffectRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 14:02'!
longDescription 
	^ 'Remove assignment has no effect. For example, var := var is unless'! !

!RBRemoveAssignmentWithoutEffectRule methodsFor: 'accessing' stamp: 'SimonAllier 9/5/2012 14:21'!
name
	^ 'Remove assignment has no effect'! !

!RBTransformationRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTransformationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'TransformationRule'! !

!RBTransformationRule methodsFor: '*Manifest-Core' stamp: ''!
isTransformationRule

	^ true ! !

!RBUnpackagedCodeRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnpackagedCodeRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnpackagedCodeRule'! !

!RBUnpackagedCodeRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:43'!
category 
	^'Potential Bugs'! !

!RBBadMessageRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBadMessageRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'BadMessageRule'! !

!RBBadMessageRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 09:59'!
category 	
	^ 'Coding Idiom Violation'! !

!RBBadMessageRule methodsFor: '*Manifest-Core' stamp: 'ah 8/2/2012 13:27'!
longDescription

	^ 'This smell arises when methods send messages that perform low level things. You might want to limit the number of such messages in your application. Messages such as #isKindOf: can signify a lack of polymorphism. You can see which methods are "questionable" by editing the RBBadMessageRule>>badSelectors method. Some examples are: #respondsTo: #isMemberOf: #performMethod: and #performMethod:arguments:'! !

!RBClassCommentsSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ClassCommentsSpellingRule'! !

!RBAssignmentWithoutEffectRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAssignmentWithoutEffectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'AssignmentWithoutEffectRule'! !

!RBAssignmentWithoutEffectRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:42'!
category
	^ 'Optimization'! !

!RBAssignmentWithoutEffectRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:41'!
longDescription 
	
	^'This smell arises when a statement such as x := x is found. This statement has not effect, it can be removed.'! !

!RBDefinesEqualNotHashRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBDefinesEqualNotHashRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'DefinesEqualNotHashRule'! !

!RBDefinesEqualNotHashRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:05'!
category 
	^ 'Potential Bugs'! !

!RBDefinesEqualNotHashRule methodsFor: '*Manifest-Core' stamp: 'ah 8/2/2012 13:12'!
longDescription

	^ 'This smell arises when a class defines #= also and not #hash. If #hash is not defined then the instances of the class might not be able to be used in sets since equal element must have the same hash.'! !

!RBLongMethodsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLongMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'LongMethodsRule'! !

!RBLongMethodsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:23'!
category
	^ 'Design Flaws'! !

!RBLongMethodsRule methodsFor: '*Manifest-Core' stamp: 'StephaneDucasse 12/30/2012 21:01'!
longDescription

	^ 'This smell arises when a long method is found (with 10 or more statements). Note that, it counts statements, not lines. Long methods should often be split into several smaller ones. When you start to have empty line to separate groups of methods, this is an indication that you should probably define a new method. 
	Do not forget that methods are unit of extensions in an object-oriented language. It means that each time you define a method a subclass may override and extend it while taking advantage and reusing the calling context of your method. This is the basis for Hook and Template Design Pattern and central to good object-oriented design. So keep your methods short. 
	Use the extract method refactoring, it even checks whether the method you are extracting already exists in the class. 
	
	The defined number of statements can be edited in RBLongMethodsRule>>longMethodSize.'! !

!RBMethodModifierSuperRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodModifierSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MethodModifierSuperRule'! !

!RBNotEliminationRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBNotEliminationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'NotEliminationRule'! !

!RBNotEliminationRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:51'!
category 
	^ 'Optimization'! !

!RBNotEliminationRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 13:16'!
longDescription 
	^ 'Eliminate unnecessary not''s.
For example test not ifTrue:[] is equivalent to test ifFalse:[]' ! !

!RBUnclassifiedMethodsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnclassifiedMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnclassifiedMethodsRule'! !

!RBUnclassifiedMethodsRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:57'!
category
	^ 'Style'! !

!RBAbstractClassRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAbstractClassRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'AbstractClassRule'! !

!RBAbstractClassRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 11:22'!
category
	^ 'Potential Bugs'! !

!RBMethodSourceContainsLinefeedsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodSourceContainsLinefeedsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MethodSourceContainsLinefeedsRule'! !

!RBMethodSourceContainsLinefeedsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 14:11'!
category
	^ 'Bugs'! !

!RBUnconditionalRecursionRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnconditionalRecursionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnconditionalRecursionRule'! !

!RBUnconditionalRecursionRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:34'!
category 
	^ 'Potential Bugs'! !

!RBVariableReferencedOnceRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBVariableReferencedOnceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'VariableReferencedOnceRule'! !

!RBVariableReferencedOnceRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:49'!
category 
	^ 'Design Flaws'! !

!RBTemporaryVariableNamesSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'TemporaryVariableNamesSpellingRule'! !

!RBCollectionMessagesToExternalObjectRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCollectionMessagesToExternalObjectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'CollectionMessagesToExternalObjectRule'! !

!RBCollectionMessagesToExternalObjectRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:21'!
category
	^'Coding Idiom Violation'! !

!RBSendsDifferentSuperRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSendsDifferentSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SendsDifferentSuperRule'! !

!RBSendsDifferentSuperRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 14:08'!
category
	^ 'Design Flaws'! !

!RBDetectContainsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBDetectContainsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'DetectContainsRule'! !

!RBDetectContainsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:24'!
category
	^'Coding Idiom Violation'! !

!RBExcessiveVariablesRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExcessiveVariablesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ExcessiveVariablesRule'! !

!RBExcessiveVariablesRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:07'!
category
	^ 'Design Flaws'! !

!RBExcessiveVariablesRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 10:45'!
longDescription

	^ 'This smell arises when a class has too many instance variables (10 or more). Such classes could be redesigned to have fewer fields, possibly through some nested object grouping. The defined number of instance variables can be edited in RBExcessiveVariablesRule>>variablesCount.'! !

!RBAsOrderedCollectionNotNeededRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAsOrderedCollectionNotNeededRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'AsOrderedCollectionNotNeededRule'! !

!RBAsOrderedCollectionNotNeededRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:19'!
category
	^'Optimization'! !

!RBVariableNotDefinedRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBVariableNotDefinedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'VariableNotDefinedRule'! !

!RBVariableNotDefinedRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:49'!
category
	^ 'Bugs'! !

!RBSendsDeprecatedMethodToGlobalRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSendsDeprecatedMethodToGlobalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SendsDeprecatedMethodToGlobalRule'! !

!RBSendsDeprecatedMethodToGlobalRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:28'!
category 
	^ 'Design Flaws'! !

!RBClassVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBClassVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ClassVariableCapitalizationRule'! !

!RBClassVariableCapitalizationRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:02'!
category
	^ 'Style'! !

!RBClassVariableCapitalizationRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 11:40'!
longDescription

	^ 'This smell arises when class or pool variable names do not start with an uppercase letter, which is a standart style in Smalltalk'! !

!RBAssignmentInIfTrueRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAssignmentInIfTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'AssignmentInIfTrueRule'! !

!RBAssignmentInIfTrueRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:48'!
category 
	^ 'Optimization'! !

!RBAssignmentInIfTrueRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 13:55'!
longDescription 
	^ 'Moving assignements outside blocks leads to shorter and more efficient code.
For example:
test 
	ifTrue: [var := 1]
	ifFlase: [var:= 2]
is equivalent to:
var :=  test 
	ifTrue: [1]
	ifFlase: [2]'! !

!RBMissingYourselfRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMissingYourselfRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MissingYourselfRule'! !

!RBMissingYourselfRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:24'!
category 
	^ 'Potential Bugs'! !

!RBMissingYourselfRule methodsFor: '*Manifest-Core' stamp: 'Sd 11/30/2012 17:05'!
longDescription

	^ 'When using cascaded messages, it is often important to finish the cascade with a yourself message. Why? for several reasons. 
	
	First the messages in the cascade may not return the last receiver but the argument as in the well known case of adding elements in a collection.
	
	| col  | 
	col := (OrderedCollection new: 2) add: 1; add: 2.
	
	In this example, col will be assigned to 2 instead of an orderedCollection because add: returns its argument and not the receiver. 
	
	The correct way to do it is using yourself (since yourself returns the receiver).
	| col  | 
	col := (OrderedCollection new: 2) add: 1; add: 2 ; yourself.
	
	
	Second case. Using yourself you can block the influence of redefined method. 
	Imagine the following example: a method creating an instance, initializing it and returning it.
	
	Box class >> new
		| inst | 
		inst := self new.
		inst initialize. 
		^ inst
		
	What this code ensures is that the instance is returned. Using ^ inst initialize would have 
	return the same (but with the risk that if initialize did not return the receiver the new method would not return the right instance)
	
	The previous code can be expressed as follow:
	
	Box class >> new
		^ self new initialize ; yourself 
		
	Here yourself play the same role as the ^ inst above. 
	
	'! !

!RBMethodCommentsSpellingRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MethodCommentsSpellingRule'! !

!RBLiteralArrayCharactersRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLiteralArrayCharactersRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'LiteralArrayCharactersRule'! !

!RBLiteralArrayCharactersRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:22'!
category 
	^ 'Optimization'! !

!RBCompositeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 13:51'!
allGoodRules
	| rules |
	
	rules :=  self rules: (self rulesClassifiedFor:  RBLintRule) name: 'All Rules'.

	self removedRules do: [:r |
			rules removeRule: r].
	
	rules removeRule: (RBCompositeLintRule new name: 'Spelling').


	rules removeRule: RBMissingTranslationsInMenusRule new.
	rules removeRule: RBGuardingClauseRule new.
	
	^ rules ! !

!RBCompositeLintRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCompositeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/31/2013 14:05'!
removedRules
	^ {(RBCompositeLintRule new name: 'Spelling').  
		RBMissingTranslationsInMenusRule new. 
		RBGuardingClauseRule new. 
		RBMethodModifierOverrideRule new.
		RBMethodModifierSuperRule new.
		RBMethodModifierFinalRule new.
		RBAssignmentWithoutEffectRule new.
		RBUtilityMethodsRule new. } "this rule is contains a bug"
	
! !

!RBCompositeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 11:08'!
rulesClassifiedFor: aRuleClass
	| groups rules |
	groups := Dictionary new.
	(self rulesFor: aRuleClass) do: [ :each |
		(groups at: each category ifAbsentPut: [ OrderedCollection new ])
			addLast: each ].
	rules := SortedCollection sortBlock: [ :a :b | a name <= b name ].
	groups keysAndValuesDo: [ :group :elements |
		rules addLast: (RBCompositeLintRule 
			rules: elements asArray
			name: group) ].
	^ rules asArray! !

!RBCompositeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'CompositeLintRule'! !

!RBCompositeLintRule methodsFor: '*Manifest-Core' stamp: 'StephaneDucasse 11/21/2012 18:25'!
leaves

	^ rules gather: [ :rule | rule leaves ]	
! !

!RBCascadedNextPutAllsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCascadedNextPutAllsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'CascadedNextPutAllsRule'! !

!RBCascadedNextPutAllsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:50'!
category 
	^ 'Coding Idiom Violation'! !

!RBOnlyReadOrWrittenVariableRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBOnlyReadOrWrittenVariableRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'OnlyReadOrWrittenVariableRule'! !

!RBOnlyReadOrWrittenVariableRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:33'!
category 	
	^ 'Optimization'! !

!RBOnlyReadOrWrittenVariableRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 12:25'!
longDescription

	^ 'This smell arises when an instance variable is not both read and written. If an instance variable is only read, the reads can be replaced by nil, since it could not have been assigned a value. If the variable is only written, then it does not need to store the result since it is never used. This check does not work for the data model classes since they use the #instVarAt:put: messages to set instance variables.'! !

!RBSentNotImplementedRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSentNotImplementedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SentNotImplementedRule'! !

!RBSentNotImplementedRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 13:51'!
category 
	^ 'Bugs'! !

!RBSentNotImplementedRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 13:49'!
longDescription

^ 'This smell arises when a message is sent by a method,  but no class in the system implements such a message. This method sent will certainly cause a doesNotUnderstand: message when they are executed.  Further this rule checks if messages sent to self or super exist in the hierarchy, since these can be statically typed.'! !

!RBLintRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLintRule class methodsFor: '*Manifest-Core' stamp: ''!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	^ 0! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 11:05'!
category
	"Bugs, Potential Bugs, Design Flaws, Coding Idiom Violation, Optinization, Style "
	^ 'Unclassified rules'! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/2/2012 11:41'!
critics
	| result |
	
	result := self result.
	
	result
		ifNil: [ ^ {} ].
		
	( result isKindOf: RBMultiEnvironment) 
		ifTrue: [ result := result asSelectorEnvironment ].
	
	result isSelectorEnvironment
		ifTrue: [ 
			| array |
			array := OrderedCollection new: result numberSelectors.
			result classes do: [:cl | 
				result selectorsForClass: cl do: [:sel | array add:  (cl>>sel)]]. 
			^ array ].
	
	^ result allClasses ! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: ''!
isTransformationRule

	^ false ! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 5/21/2012 14:38'!
leaves 
	^ {self}! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 8/22/2012 11:22'!
longDescription
	^ self rationale ! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: ''!
result
	^ self subclassResponsibility! !

!RBJustSendsSuperRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBJustSendsSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'JustSendsSuperRule'! !

!RBJustSendsSuperRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:21'!
category
	^ 'Optimization'! !

!RBJustSendsSuperRule methodsFor: '*Manifest-Core' stamp: 'StephaneDucasse 12/30/2012 20:45'!
longDescription

	^ 'This smell arises when a method just forwards the message to its superclass. This often happens due to code changes or when you simply forget that you wanted to extend the behavior of a superclass method. These methods can be removed.'! !

!RBLiteralArrayContainsCommaRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLiteralArrayContainsCommaRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'LiteralArrayContainsCommaRule'! !

!RBLiteralArrayContainsCommaRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 14:13'!
category 
	^ 'Coding Idiom Violation'! !

!RBAssignmentInBlockRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAssignmentInBlockRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'AssignmentInBlockRule'! !

!RBAssignmentInBlockRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:20'!
category
	^'Coding Idiom Violation'! !

!RBEqualNilRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEqualNilRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'EqualNilRule'! !

!RBEqualNilRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:50'!
category 
	^ 'Coding Idiom Violation'! !

!RBEqualNilRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 14:38'!
longDescription 
	^ 'Replaces = nil and == nil by isNil, ~= nil and ~~ nil by notNil, '! !

!RBSuperSendsNewRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSuperSendsNewRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SuperSendsNewRule'! !

!RBSuperSendsNewRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:19'!
category 
	^ 'Bugs'! !

!RBSuperSendsNewRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:19'!
longDescription 
	^' This rule checks for method that wrongly initialize an object twice. Contrary to other Smalltalk implementations Pharo automatically calls #initiailize on object creation.
For example, a warning is raised when the statment self new initialize is found in a method.'! !

!RBTemporaryVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTemporaryVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'TemporaryVariableCapitalizationRule'! !

!RBTemporaryVariableCapitalizationRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:20'!
category
	^ 'Style'! !

!RBTemporaryVariableCapitalizationRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 15:07'!
longDescription

	^ 'This smell arises when a temporary or argument variable do not start with a lowercase letter, which is a standart style in Smalltalk.'! !

!RBThreeElementPointRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBThreeElementPointRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ThreeElementPointRule'! !

!RBThreeElementPointRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:32'!
category 
	^ 'Potential Bugs'! !

!RBUnderscoreAssignmentRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnderscoreAssignmentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnderscoreAssignmentRule'! !

!RBUnderscoreAssignmentRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:52'!
category
	^ 'Style'! !

!RBUnoptimizedToDoRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnoptimizedToDoRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnoptimizedToDoRule'! !

!RBUnoptimizedToDoRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:35'!
category 
	^ 'Optimization'! !

!RGMetaclassDefinition class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 7/26/2012 15:57'!
manifestReadOn: aArray

	^ (self named:( aArray at:1))
		baseClass: ( aArray at:2)! !

!RGMetaclassDefinition methodsFor: '*Manifest-Core' stamp: 'SimonAllier 7/26/2012 15:52'!
arrayStringForManifest
	|array|
	
	array := Array new:2.
	
	array at: 1 put:  (self class asString asSymbol).
	array at: 2 put: { name asSymbol. self theNonMetaClass asSymbol}.
	
	^ array 
	 ! !

!RGMetaclassDefinition methodsFor: '*Manifest-Core' stamp: ''!
storeOn: aStream
	
	aStream nextPut: $(. 
	super storeOn: aStream.
	aStream nextPutAll: ' baseClass:'.
	self theNonMetaClass storeOn: aStream.
	aStream nextPut: $).
	
! !

!RBClassInstVarNotInitializedRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBClassInstVarNotInitializedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ClassInstVarNotInitializedRule'! !

!RBClassInstVarNotInitializedRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:00'!
category 	
	
	^ 'Potential Bugs'! !

!RBOverridesSpecialMessageRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBOverridesSpecialMessageRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'OverridesSpecialMessageRule'! !

!RBOverridesSpecialMessageRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:34'!
category
	^ 'Bugs'! !

!RBOverridesSpecialMessageRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/12/2012 11:28'!
longDescription 

	^ 'Checks that a class does not override a message that is essential to the base system. For example, if you override the #class method from object, you are likely to crash your image.
In the class the messages we should not override are: ',  (', ' join: (self classShouldNotOverride) ),'.
In the class side the messages we should not override are: ',  (', ' join: (self metaclassShouldNotOverride) ),'.' ! !

!RBConsistencyCheckRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBConsistencyCheckRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ConsistencyCheckRule'! !

!RBConsistencyCheckRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:24'!
category
	^'Coding Idiom Violation'! !

!RBExcessiveMethodsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExcessiveMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ExcessiveMethodsRule'! !

!RBExcessiveMethodsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:06'!
category
	^ 'Design Flaws'! !

!RBExcessiveMethodsRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 10:42'!
longDescription

	^ 'This smell arises when a large class is found (with 40 or more methods). Large classes are indications that it has too much responsibility. Try to break it down, and reduce the size to something manageable. The defined number of methods can be edit in RBExcessiveMethodsRule>>methodsCount.'! !

!RBOnlyReadOrWrittenTemporaryRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBOnlyReadOrWrittenTemporaryRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'OnlyReadOrWrittenTemporaryRule'! !

!RBOnlyReadOrWrittenTemporaryRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:26'!
category 
	^ 'Optimization'! !

!RBClassNameInSelectorRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBClassNameInSelectorRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ClassNameInSelectorRule'! !

!RBClassNameInSelectorRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:01'!
category 
	^ 'Style'! !

!RBClassNameInSelectorRule methodsFor: '*Manifest-Core' stamp: 'ah 8/2/2012 13:03'!
longDescription

	^ 'This smell arises when the class name is found in a selector. This is redundant since to call the you must already refer to the class name. For example, #openHierarchyBrowserFrom: is a redundant name for HierarchyBrowser.'! !

!RBSendsUnknownMessageToGlobalRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSendsUnknownMessageToGlobalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SendsUnknownMessageToGlobalRule'! !

!RBSendsUnknownMessageToGlobalRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:29'!
category 
	^ 'Bugs'! !

!RBVariableAssignedLiteralRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBVariableAssignedLiteralRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'VariableAssignedLiteralRule'! !

!RBVariableAssignedLiteralRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:48'!
category
	^ 'Design Flaws'! !

AbstractTool subclass: #BuilderManifest
	instanceVariableNames: 'manifestClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!BuilderManifest commentStamp: '<historical>' prior: 0!
A ManifestBuilder is used to create, read and write a Manifest 

Instance Variables
	manifestClass:		<Object>

manifestClass
	- xxxxx
!

!BuilderManifest class methodsFor: 'utils' stamp: ''!
allManifestClasses

	^ Smalltalk allClasses select: [:class | class isManifest]! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
falsePositiveBeginningTag
	"the string that identifies uniquely the beginning of a selector who give  the set of false positive for a rule"
	
	^ 'rule'! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
falsePositiveEndTag
	"the string that identifies uniquely the end of a selector who give  the set of false positive for a rule"
	
	^ 'FalsePositive'! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
falsePositiveMiddleTag
	"the string that identifies uniquely the middle of a selector who give  the set of false positive for a rule"
	
	^ 'V'! !

!BuilderManifest class methodsFor: 'instance creation' stamp: 'SimonAllier 2/1/2013 11:38'!
hasManifestFor: aItem

	^  (self new manifestOf: aItem) isNil not
		! !

!BuilderManifest class methodsFor: 'instance creation' stamp: 'SimonAllier 2/1/2013 11:34'!
hasPackageNamed: aPackageName

	^ self allManifestClasses 
		anySatisfy: [:each | each category = aPackageName  ]
	! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
manifestTag
	"the string that identifies uniquely the beginning of a Manifest class name"
	
	^ 'Manifest'! !

!BuilderManifest class methodsFor: 'instance creation' stamp: 'SimonAllier 2/1/2013 12:53'!
of: aItem
	| mb  |

	mb := self new. 
	(mb manifestOf: aItem) isNil 
			ifTrue: [mb createManifestOf: aItem]
		 	ifFalse: [ mb isObsoleteManifest 
				ifTrue: [
					mb manifest theNonMetaClass removeFromSystem.
					mb createManifestOf: aItem]].
	
	^ mb	
! !

!BuilderManifest class methodsFor: 'instance creation' stamp: 'SimonAllier 2/1/2013 12:53'!
ofPackageNamed: aPackageName
	| mb manifestClass |
	
	mb := self new. 
	manifestClass := self allManifestClasses 
		detect: [:each | each category = aPackageName  ]
		ifNone: [ nil ].
		
	manifestClass isNil 
		ifTrue: [mb createManifestNamed: aPackageName	 ] 
	 	ifFalse:[ mb manifestClass: manifestClass]. 	

	^ mb	
! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
rejectClassesTag
	"the string that identifies uniquely the beginning of a selector who give  the set of rejected classes"
	
	^ 'rejectClasses'! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
rejectRulesTag
	"the string that identifies uniquely the beginning of a selector who give  the set of rejected rules"
	
	^ 'rejectRules'! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
toDoBeginningTag
	"the string that identifies uniquely the beginning of a selector who give  the set of TODO for a rule"
	
	^ 'rule'! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
toDoEndTag
	"the string that identifies uniquely the end of a selector who give  the set of TODO for a rule"
	
	^ 'TODO'! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
toDoMiddleTag
	"the string that identifies uniquely the middle of a selector who give  the set of TODO for a rule"
	
	^ 'V'! !

!BuilderManifest class methodsFor: 'utils' stamp: ''!
truePositiveEndTag
	"the string that identifies uniquely the end of a selector who give  the set of false positive for a rule"
	
	^ 'TruePositive'! !

!BuilderManifest methodsFor: 'comparing' stamp: 'SimonAllier 5/22/2012 17:10'!
= aObject

	^ aObject class = self class and: [manifestClass = aObject manifest ]! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:10'!
addAllFalsePositive: fp of: ruleId version: versionId
	| selector  |
	
	selector := self selectorFalsePositiveOf: ruleId version: versionId. 
	self addAllItem: fp selector: selector.
	
	(self containsToDo: fp onRule: ruleId version: versionId)
		ifTrue: [self removeToDo: fp of:  ruleId version: versionId]. ! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 8/1/2012 15:10'!
addAllItem: aSet selector: selector
	| set  newSet arrayString |
	
	set := (manifestClass perform: selector) asOrderedCollection .
		
	newSet :=  aSet \  (self unwrap: set).
	newSet isEmpty ifTrue: [^ self].		
			
	set addAll: (newSet collect: [:fp |
		{fp asRingDefinition arrayStringForManifest. DateAndTime current asString}]). 		
		
	
	arrayString := self buildArrayString: set.
	
	manifestClass class 
		compile: (selector asString,  Character cr asString, '^ ',arrayString)
		classified: 'meta data'! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 2/8/2013 13:33'!
addAllToDo: aSet of: ruleId version: versionId
	| selector |
	
	selector := self selectorToDoOf: ruleId version: versionId. 
	self addAllItem: aSet selector: selector. ! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:14'!
addFalsePositive: fp of: ruleId version: versionId
	| selector  |
	
	selector := self selectorFalsePositiveOf: ruleId version: versionId. 
	self addItem: fp selector: selector.
	
	(self containsToDo: fp onRule: ruleId version: versionId)
		ifTrue: [self removeToDo: fp of:  ruleId version: versionId]. ! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 13:31'!
addFalsePositive: fp withComment: aString of: ruleId version: versionId
	| selector  |
	
	selector := self selectorFalsePositiveOf: ruleId version: versionId. 
	self addItem: fp wihtComment: aString selector: selector.
	
	(self containsToDo: fp onRule: ruleId version: versionId)
		ifTrue: [self removeToDo: fp of:  ruleId version: versionId]. ! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 8/1/2012 15:14'!
addItem: fp selector: selector
	self addAllItem: {fp} selector: selector! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 8/1/2012 13:31'!
addItem: fp wihtComment: aString selector: selector 
	| set unwrapSet arrayString critic |
	
	set := (manifestClass perform: selector) asOrderedCollection .

	unwrapSet := self unwrap: set.
	(unwrapSet anySatisfy: [:each | each = fp])
		ifTrue:[ critic := set at: (unwrapSet indexOf: fp). 
			set removeIndex: (unwrapSet indexOf: fp).
			set add: { critic at: 1. critic at: 2. aString}]
		ifFalse: [set add: {fp asRingDefinition storeString. DateAndTime current asString. aString}].
	

	arrayString := self buildArrayString: set.
	
	manifestClass class 
		compile: (selector asString,  Character cr asString, '^ ',arrayString)
		classified: 'meta data'! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 7/26/2012 16:03'!
addRejectClass: aClass

	|  falsePositives |
	
	falsePositives := manifestClass rejectClasses asOrderedCollection .
	
	((self unwrap: falsePositives) anySatisfy: [:each | each = aClass])
		ifTrue:[ ^ self].
	
	falsePositives add: {aClass asRingDefinition arrayStringForManifest. DateAndTime current asString}..
	 
	manifestClass class 
		compile: (self class rejectClassesTag, Character cr asString, '^ ',  (self buildArrayString: falsePositives))
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: ''!
addRejectRule: ruleId 

	|  nfp |	
	nfp := manifestClass rejectRules asSet.
	nfp add: ruleId.
	nfp := nfp asArray.
	manifestClass class compile: 
		(self class rejectRulesTag, Character cr asString, '^ ', nfp asString)
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:14'!
addToDo: fp of: ruleId version: versionId
	| selector |
	
	selector := self selectorToDoOf: ruleId version: versionId. 
	self addItem: fp selector: selector.
	
	(self containsFalsePositive: fp onRule: ruleId version: versionId)
		ifTrue: [self removeFalsePositive: fp of:  ruleId version: versionId ]! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 13:31'!
addToDo: fp withComment: aString  of: ruleId version: versionId
	| selector |
	
	selector := self selectorToDoOf: ruleId version: versionId. 
	self addItem: fp wihtComment: aString  selector: selector.
	
	(self containsFalsePositive: fp onRule: ruleId version: versionId)
		ifTrue: [self removeFalsePositive: fp of:  ruleId version: versionId ]! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:14'!
addTruePositive: fp of: ruleId version: versionId
	| selector  |
	
	selector := self selectorTruePositiveOf: ruleId version: versionId. 
	self addItem: fp selector: selector.
	
	(self containsToDo: fp onRule: ruleId version: versionId)
		ifTrue: [self removeToDo: fp of:  ruleId version: versionId]. 
	
	(self containsFalsePositive: fp onRule: ruleId version: versionId)
		ifTrue: [self removeFalsePositive: fp of:  ruleId version: versionId ]

	
	! !

!BuilderManifest methodsFor: 'private' stamp: 'Sd 11/30/2012 16:45'!
buildArrayString: aCollection
	
	^ String streamContents: [:stream | 
		stream << '#('.
		aCollection do: [:each |  
			stream  nextPutAll: '#('.
			stream nextPutAll: each first printString.
			stream  nextPutAll: ' '.
			stream nextPutAll: (each at: 2) asSymbol  printString.
			(each size = 3) ifTrue: [
				stream  nextPutAll: ' '.
				stream nextPutAll: (each at: 3) printString] .
			stream  nextPutAll: ') '.].
		stream << ')']! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:53'!
cleanUp
	| tagfp |

	tagfp := self class falsePositiveBeginningTag.
	
	manifestClass class methodDict do: [:method |
		((method selector asString beginsWith: tagfp) or:
			[method selector asString beginsWith: tagfp])
				ifTrue: [self removeObsoleteFalsePositiveOf: method]]
	
	


! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 7/26/2012 16:13'!
commentOfFalsePositive: aItem onRule: ruleId version: versionId
	| ringobject critic critics|

	 (self hasFalsePositiveOf: ruleId version: versionId)
		ifFalse: [^ self].
	
	 ringobject := aItem asRingDefinition. 
	critics := manifestClass perform: (self selectorFalsePositiveOf: ruleId version: versionId).

	critic := critics detect: [:each | ((Smalltalk at: (each first first)) manifestReadOn:  (each first at:2))  =  ringobject ]
		 ifNone: [^ ''].
	
	^ (critic size = 3)	
		ifTrue: [(critic at: 3) asString]
		ifFalse: ['']
		! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 8/1/2012 17:34'!
commentOfToDo: aItem onRule: ruleId version: versionId
	| ringobject critic critics|

	 (self hasToDoOf: ruleId version: versionId)
		ifFalse: [^ self].
	
	 ringobject := aItem asRingDefinition. 
	critics := manifestClass perform: (self selectorToDoOf: ruleId version: versionId).

	critic := critics detect: [:each | ((Smalltalk at: (each first first)) manifestReadOn:  (each first at:2))=  ringobject ]
		 ifNone: [^ ''].
	
	^ (critic size = 3)	
		ifTrue: [(critic at: 3) asString]
		ifFalse: ['']
		! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
containsFalsePositive: aItem onRule: ruleId version: versionId

	^  (self hasFalsePositiveOf: ruleId version: versionId) 
		and: [(self falsePositiveOf: ruleId version: versionId) 
			anySatisfy: [:fp| fp = aItem]] ! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
containsRejectedClass: aClass
	
	^ self rejectClasses anySatisfy: [:cl| cl = aClass]! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
containsRejectedRule: aRuleId
	
	^ self rejectRules  anySatisfy: [:fp| fp = aRuleId]! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
containsToDo: aItem onRule: ruleId version: versionId

	^  (self hasToDoOf: ruleId version: versionId) 
		and: [(self toDoOf: ruleId version: versionId) 
			anySatisfy: [:fp| fp = aItem]] ! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 3/29/2012 13:01'!
containsTruePositive: aItem onRule: ruleId version: versionId

	^  (self hasTruePositiveOf: ruleId version: versionId) 
		and: [(self truePositiveOf: ruleId version: versionId) 
			anySatisfy: [:fp| fp = aItem]] ! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 1/31/2013 11:16'!
createManifestNamed: packageName


	 manifestClass := Object subclass: (self class manifestTag, packageName onlyLetters) asSymbol
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: packageName.
	
	manifestClass class 
		compile: (self class rejectClassesTag, Character cr asString, '^ #()')
		classified: 'meta data'.
	
	manifestClass class compile: 
		(self class rejectRulesTag, Character cr asString, '^ #()')
		classified: 'meta data'.		
	
	
	^ manifestClass! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 1/30/2013 16:47'!
createManifestOf: elem

	self createManifestNamed: (self packageNameOf: elem).! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 7/26/2012 16:14'!
dateOfFalsePositive: aItem onRule: ruleId version: versionId
	| ringobject dateAndTime critics|

	 (self hasFalsePositiveOf: ruleId version: versionId)
		ifFalse: [^ self].
	
	 ringobject := aItem asRingDefinition. 
	critics := manifestClass perform: (self selectorFalsePositiveOf: ruleId version: versionId).

	dateAndTime := (critics detect: [:each | ((Smalltalk at: (each first first)) manifestReadOn:  (each first at:2))  =  ringobject ]) at: 2.
	
	
	^ dateAndTime asDateAndTime
		
		! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 8/1/2012 17:35'!
dateOfToDo: aItem onRule: ruleId version: versionId
	| ringobject dateAndTime critics|

	 (self hasFalsePositiveOf: ruleId version: versionId)
		ifFalse: [^ self].
	
	 ringobject := aItem asRingDefinition. 
	critics := manifestClass perform:  (self selectorToDoOf: ruleId version: versionId).

	dateAndTime := (critics detect: [:each | ((Smalltalk at: (each first first)) manifestReadOn:  (each first at:2)) =  ringobject ]) at: 2.
	
	
	^ dateAndTime asDateAndTime
		
		! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 5/29/2012 14:03'!
dateOfTruePositive: aItem onRule: ruleId version: versionId
	| ringobject dateAndTime critics|

	 (self hasFalsePositiveOf: ruleId version: versionId)
		ifFalse: [^ self].
	
	 ringobject := aItem asRingDefinition. 
	critics := manifestClass perform: (self selectorTruePositiveOf: ruleId version: versionId).

	dateAndTime := (critics detect: [:each | (Object readFrom: (each first)) =  ringobject ]) at: 2.
	
	
	^ dateAndTime asDateAndTime
		
		! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 5/29/2012 14:41'!
falsePositiveOf: ruleId version: versionId 

	^ self unwrap: (
		manifestClass perform: (self selectorFalsePositiveOf: ruleId version: versionId))! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
hasFalsePositiveOf: ruleId version: versionId
	^ manifestClass respondsTo: (self selectorFalsePositiveOf: ruleId version: versionId)  
	! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
hasToDoOf: ruleId version: versionId
	^ manifestClass respondsTo: (self selectorToDoOf: ruleId version: versionId)  
	! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
hasTruePositiveOf: ruleId version: versionId
	^ manifestClass respondsTo: (self selectorTruePositiveOf: ruleId version: versionId)  
	! !

!BuilderManifest methodsFor: 'comparing' stamp: 'SimonAllier 5/23/2012 15:27'!
hash
	self flag: 'fct a revoir'.
	^ manifestClass hash! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
installFalsePositiveOf: ruleId version: versionId
	"self installFalsePositiveForRule: 1 "
	
	manifestClass class 
		compile: ((self selectorFalsePositiveOf: ruleId version: versionId) asString, '^ #()')
		classified: 'meta data'! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
installToDoOf: ruleId version: versionId
	
	manifestClass class 
		compile: ((self selectorToDoOf: ruleId version: versionId) asString, '^ #()')
		classified: 'meta data'! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
installTruePositiveOf: ruleId version: versionId
	"self installFalsePositiveForRule: 1 "
	
	manifestClass class 
		compile: ((self selectorTruePositiveOf: ruleId version: versionId) asString, '^ #()')
		classified: 'meta data'! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 1/25/2013 13:32'!
isFalsePositive: aItem onRule: ruleId version: versionId
	| class |
	
	class :=  aItem isCompiledMethod
			ifTrue: 	[aItem methodClass]
			ifFalse: [aItem].
			
	^ ((self containsFalsePositive: aItem onRule:  ruleId version: versionId) or:
			[(self containsRejectedRule: ruleId) or:
				[self containsRejectedClass: class]])! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 1/22/2013 17:25'!
isObsoleteManifest
	|methodDico|
	
	methodDico := manifestClass class methodDictionary.
	
	^methodDico isEmpty 
		or: [methodDico anySatisfy: [:method | |selector|
				selector := method selector.
				(#(#rejectClass. #rejectRules) includes: selector)
					ifTrue: [false]
					ifFalse: [
			(manifestClass perform: selector) anySatisfy: [ :each | 
				(each first first) = (Character value: 40)]]]  ]! !

!BuilderManifest methodsFor: 'accessing' stamp: ''!
manifest
	^ manifestClass! !

!BuilderManifest methodsFor: 'accessing' stamp: 'SimonAllier 8/21/2012 14:52'!
manifestClass: aClass
		
	 manifestClass := aClass
		
! !

!BuilderManifest methodsFor: 'accessing' stamp: 'SimonAllier 1/30/2013 16:46'!
manifestOf: elem

	| packageName |
	packageName := self packageNameOf: elem.

	manifestClass := self class allManifestClasses 
		detect: [:each | each category = packageName  ]
		ifNone: [ nil ].
		
	^ manifestClass
		
! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 1/21/2013 14:49'!
packageNameOf: elem

	
	elem isCompiledMethod 
		ifTrue: [MCWorkingCopy managersForClass: (elem methodClass) selector: (elem selector) do: [: package | ^ package packageName ]]	
			"(RPackageOrganizer default packageOf: elem ) name"
		ifFalse: [MCWorkingCopy managersForClass: elem  do: [: package | ^ package packageName ]]	
				"(RPackageOrganizer default packageDefiningOrExtendingMethod: elem ) name"! !

!BuilderManifest methodsFor: 'printing' stamp: 'SimonAllier 5/23/2012 15:19'!
printOn: aStream

	aStream nextPutAll: 'ManifestBuilder of ';
		nextPutAll: manifestClass name! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
rejectClasses
	^ self unwrap: (manifestClass rejectClasses)
! !

!BuilderManifest methodsFor: 'manifest' stamp: ''!
rejectRules
	
	^ (manifestClass respondsTo: #rejectRules)
		ifTrue: [manifestClass rejectRules]
		ifFalse: [ #() ]
	
! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:16'!
removeAllFalsePositive: aSet of: ruleId version: versionId
	| selector  |
	
	selector := self selectorFalsePositiveOf:ruleId version: versionId. 
	self removeAllItem: aSet  selector: selector.
	! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 8/1/2012 15:16'!
removeAllItem: aSet selector: selector
	| set arrayString |
	
	set := (manifestClass perform: selector) asOrderedCollection .
	
	set := set reject: [:each | |tmp|
		tmp :=  (Smalltalk at: (each first first)) manifestReadOn:  (each first at:2).
		aSet anySatisfy: [:fp | tmp =  fp asRingDefinition ]].	

	arrayString := self buildArrayString: set.
	
	manifestClass class 
		compile: (selector asString,  Character cr asString, '^ ',arrayString)
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 4/13/2012 17:13'!
removeAllManifest
 
	self removeClasses: (self class allManifestClasses)! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:17'!
removeAllToDo: fp of: ruleId version: versionId
	| selector |
	
	selector := self selectorToDoOf:ruleId version: versionId. 
	self removeAllItem: fp selector: selector.
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:17'!
removeFalsePositive: fp of: ruleId version: versionId
	| selector  |
	
	selector := self selectorFalsePositiveOf:ruleId version: versionId. 
	
	self removeItem: fp selector: selector.
	
	! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 8/1/2012 15:17'!
removeItem: fp selector: selector
	self removeAllItem: {fp} selector: selector! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 4/13/2012 17:08'!
removeManifestOf: aItem
	
	( self manifestOf: aItem ) ifNotNil: [ :manifest | 
			self removeClass: manifest ]! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 7/26/2012 16:12'!
removeObsoleteFalsePositiveOf: aMethod
	| set arrayString  |
	set := (manifestClass perform: aMethod selector) asOrderedCollection.
	set := set select: [ :each |((Smalltalk at: (each first first)) manifestReadOn:  (each first at:2))  isDefined ].
	arrayString := self buildArrayString: set.
	manifestClass class
		compile: aMethod selector asString , Character cr asString , '^ ' , arrayString
		classified: 'meta data'! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 7/26/2012 16:12'!
removeRejectClass: aClass

	|  classes |
	classes :=  manifestClass rejectClasses asOrderedCollection .
	
	classes := classes reject: [:each | 
			((Smalltalk at: (each first first)) manifestReadOn:  (each first at:2)) =  aClass asRingDefinition ].	
	 
	manifestClass class 
		compile: (self class rejectClassesTag, Character cr asString, '^ ',  (self buildArrayString: classes))
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: ''!
removeRejectRule: ruleId 

	|  nfp |	
	nfp := manifestClass rejectRules asOrderedCollection.
	nfp remove: ruleId ifAbsent: [^ self].
	
	nfp := nfp asArray.
	manifestClass class 
		compile: (self class rejectRulesTag, Character cr asString, '^ ', nfp asString)
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 8/1/2012 15:17'!
removeToDo: fp of: ruleId version: versionId
	| selector |
	
	selector := self selectorToDoOf:ruleId version: versionId. 
	self removeItem: fp selector: selector.
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 5/29/2012 11:19'!
resetFalsePositiveOf: ruleId version: versionId
 
	self  installFalsePositiveOf: ruleId version: versionId. ! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 5/29/2012 11:21'!
resetToDoOf: ruleId version: versionId
 	
	self installToDoOf: ruleId version: versionId. ! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 4/13/2012 17:02'!
selectorFalsePositiveOf: ruleId version: versionId
	^ (self class falsePositiveBeginningTag, ruleId ,
	self class falsePositiveMiddleTag, versionId asString,
	self class falsePositiveEndTag) 
		asSymbol.! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 4/13/2012 17:02'!
selectorToDoOf: ruleId version: versionId
	^ (self class toDoBeginningTag, ruleId ,
	self class toDoMiddleTag, versionId asString,
	self class toDoEndTag) 
		asSymbol.! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 4/13/2012 17:02'!
selectorTruePositiveOf: ruleId version: versionId
	^ (self class falsePositiveBeginningTag, ruleId ,
	self class falsePositiveMiddleTag, versionId asString,
	self class truePositiveEndTag) 
		asSymbol.! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 5/29/2012 14:04'!
toDoOf: ruleId version: versionId 

	^ self unwrap: (
		manifestClass perform: (self selectorToDoOf: ruleId version: versionId))! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 5/29/2012 14:04'!
truePositiveOf: ruleId version: versionId 

	^ self unwrap: (
		manifestClass 
			perform:   (self selectorTruePositiveOf: ruleId version: versionId))! !

!BuilderManifest methodsFor: 'private' stamp: 'SimonAllier 9/11/2012 15:43'!
unwrap: aCollection
	| unwrapCollection rgobject |

	unwrapCollection := OrderedCollection new.
	aCollection
		do: [ :each | 
		"	(each first first) = (Character value: 40) ifFalse: ["
			rgobject := (Smalltalk at: (each first first)) manifestReadOn:  (each first at:2).
			(rgobject isClass and: [ rgobject  realClass notNil ])
				ifTrue: [ unwrapCollection add: rgobject realClass ].
			(rgobject isMethod and: [ rgobject method notNil ])
				ifTrue: [ unwrapCollection add: rgobject method ] ].
	^ unwrapCollection! !

!RBMissingSubclassResponsibilityRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMissingSubclassResponsibilityRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MissingSubclassResponsibilityRule'! !

!RBMissingSubclassResponsibilityRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 10:28'!
category 
	^ 'Design Flaws'! !

!RBMissingSubclassResponsibilityRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 12:14'!
longDescription

	^ 'This smell arises when a class defines a method in all subclasses, but not in itself as an abstract method. Such methods should most likely be defined as subclassResponsibility methods. Furthermore, this check helps to find similar code that might be occurring in all the subclasses that should be pulled up into the superclass.'! !

!RBMethodModifierFinalRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodModifierFinalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'MethodModifierFinalRule'! !

!RBUtilityMethodsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUtilityMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UtilityMethodsRule'! !

!RBUtilityMethodsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:46'!
category 		
	^ 'Design Flaws'! !

!RBIfTrueReturnsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBIfTrueReturnsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'IfTrueReturnsRule'! !

!RBIfTrueReturnsRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:21'!
category 
	^ 'Optimization'! !

!RBContainsRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBContainsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ContainsRule'! !

!RBContainsRule methodsFor: '*Manifest-Core' stamp: 'Simon 8/30/2012 14:51'!
category
	^ 'Optimization'! !

!RBIfTrueBlocksRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBIfTrueBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'IfTrueBlocksRule'! !

!RBIfTrueBlocksRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:34'!
category
	^ 'Optimization'! !

!RBUnoptimizedAndOrRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnoptimizedAndOrRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UnoptimizedAndOrRule'! !

!RBUnoptimizedAndOrRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:34'!
category 
	^ 'Optimization'! !

!RBUsesTrueRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUsesTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'UsesTrueRule'! !

!RBUsesTrueRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 13:46'!
category 	
	^ 'Bugs'! !

!RGClassDescriptionDefinition class methodsFor: '*manifest-core' stamp: 'SimonAllier 8/22/2012 16:30'!
manifestReadOn: aArray

	^ self named:( aArray first)! !

!RGClassDescriptionDefinition methodsFor: '*Manifest-Core' stamp: 'SimonAllier 7/26/2012 15:51'!
arrayStringForManifest
	|array|
	
	array := Array new:2.
	
	array at: 1 put:  (self class asString asSymbol).
	array at: 2 put: { name asSymbol.}.
	
	^ array 
	 ! !

!RGClassDescriptionDefinition methodsFor: '*Manifest-Core' stamp: ''!
storeOn: aStream

	aStream nextPutAll: '('; nextPutAll: self class name; 
			nextPutAll: ' named: #'; nextPutAll: name;
			nextPut: $).
			! !

!RBEqualsTrueRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEqualsTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'EqualsTrueRule'! !

!RBEqualsTrueRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/6/2012 16:27'!
category
	^'Optimization'! !

!RBReturnInEnsureRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBReturnInEnsureRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ReturnInEnsureRule'! !

!RBReturnInEnsureRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:27'!
category 
	^ 'Potential Bugs'! !

!RBBasicLintRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBasicLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'BasicLintRule'! !

!RBReturnsBooleanAndOtherRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBReturnsBooleanAndOtherRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'ReturnsBooleanAndOtherRule'! !

!RBReturnsBooleanAndOtherRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 11:22'!
category
	^ 'Potential Bugs'! !

!RBReturnsBooleanAndOtherRule methodsFor: '*Manifest-Core' stamp: 'ah 8/6/2012 13:16'!
longDescription

	^ 'This smell arises when a method return a boolean value (true or false) and return some other value such as (nil or self). If the method is suppose to return a boolean, then this signifies that there is one path through the method that might return a non-boolean. If the method doesn''t need to return a boolean, it should be probably rewriten to return some non-boolean value since other programmers reading the method might assume that it returns a boolean.'! !

!RBStringConcatenationRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBStringConcatenationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'StringConcatenationRule'! !

!RBStringConcatenationRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:31'!
category 
	^ 'Optimization'! !

!RBStringConcatenationRule methodsFor: '*Manifest-Core' stamp: 'Sd 11/30/2012 16:51'!
longDescription 
	^  'Check for string concatenation inside some iteration message. Since string concatenation is O(n^2), it is better to use streaming since it is O(n) - assuming that n is large enough. As a general principal avoid , since the receiver is copied. Therefore chaining , messages will lead to multiple useless copies of the receiver. 

Instead of writing
	| string | 
	string := String new.
	#(1 2 3) do: [ :each |
		string := string, each asString].
	^ string

Write, it is much more efficient.

	String streamContents: [:s | 
		#(1 2 3)  do: [:each | s nextPutAll: each asString]]'
! !

!RBTempVarOverridesInstVarRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTempVarOverridesInstVarRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'TempVarOverridesInstVarRule'! !

!RBTempVarOverridesInstVarRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 13:59'!
category
	^ 'Potential Bugs'! !

!RBSizeCheckRule class methodsFor: '*Manifest-Core' stamp: ''!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSizeCheckRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 4/13/2012 16:58'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'SizeCheckRule'! !

!RBSizeCheckRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 9/7/2012 10:30'!
category 
	^ 'Optimization'! !

Object subclass: #ManifestManifestCore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!ManifestManifestCore class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
rejectClasses
^ #()! !

!ManifestManifestCore class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
rejectRules
^ #('MethodHasNoTimeStampRule')! !

!ManifestManifestCore class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleBadMessageRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#BuilderManifest #hasTruePositiveOf:version: #false)) #'2013-02-01T15:29:51.978000008+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #hasFalsePositiveOf:version: #false)) #'2013-02-01T15:29:51.978000006+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #rejectRules #false)) #'2013-02-01T15:29:51.978000007+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #hasToDoOf:version: #false)) #'2013-02-01T15:29:51.978000005+01:00') )! !

!ManifestManifestCore class methodsFor: 'meta data' stamp: 'SimonAllier 2/6/2013 15:08'!
ruleCodeCruftLeftInMethodsRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#BuilderManifest #hash #false)) #'2013-02-06T15:08:33.234+01:00') )! !

!ManifestManifestCore class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleConsistencyCheckRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#BuilderManifest #addItem:wihtComment:selector: #false)) #'2013-02-01T15:29:51.672000001+01:00') #(#(#RGMethodDefinition #(#'RGMetaclassDefinition class' #manifestReadOn: #true)) #'2013-02-01T15:29:51.672000002+01:00') #(#(#RGMethodDefinition #(#'RGMethodDefinition class' #manifestReadOn: #true)) #'2013-02-01T15:29:51.672000003+01:00') )! !

!ManifestManifestCore class methodsFor: 'meta data' stamp: 'SimonAllier 2/8/2013 16:35'!
ruleContainsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#BuilderManifest #commentOfFalsePositive:onRule:version: #false)) #'2013-02-01T15:29:52.876+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #commentOfToDo:onRule:version: #false)) #'2013-02-01T15:29:52.876000001+01:00') #(#(#RGMethodDefinition #(#SmalllintManifestChecker #criticsOf: #false)) #'2013-02-08T16:35:58.019+01:00') )! !

!ManifestManifestCore class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleEquivalentSuperclassMethodsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#'RBEqualNotUsedRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000004+01:00') #(#(#RGMethodDefinition #(#'RBEndTrueFalseRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000018+01:00') #(#(#RGMethodDefinition #(#'RBBlockLintRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000009+01:00') #(#(#RGMethodDefinition #(#'RBDetectContainsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000036+01:00') #(#(#RGMethodDefinition #(#'RBMethodModifierSuperRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000029+01:00') #(#(#RGMethodDefinition #(#'RBExcessiveArgumentsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000001+01:00') #(#(#RGMethodDefinition #(#'RBVariableNotDefinedRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000007+01:00') #(#(#RGMethodDefinition #(#'RBVariableAssignedLiteralRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000009+01:00') #(#(#RGMethodDefinition #(#'RBDetectIfNoneRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000028+01:00') #(#(#RGMethodDefinition #(#'RBPlatformDependentUserInteractionRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000006+01:00') #(#(#RGMethodDefinition #(#'RBMissingSuperSendsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000048+01:00') #(#(#RGMethodDefinition #(#'RBOnlyReadOrWrittenVariableRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000005+01:00') #(#(#RGMethodDefinition #(#'RBMinMaxRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.465000002+01:00') #(#(#RGMethodDefinition #(#'RBAbstractClassRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000051+01:00') #(#(#RGMethodDefinition #(#'RBUnoptimizedAndOrRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000019+01:00') #(#(#RGMethodDefinition #(#'RBMethodModifierFinalRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000053+01:00') #(#(#RGMethodDefinition #(#'RBUsesAddRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000011+01:00') #(#(#RGMethodDefinition #(#'RBUnclassifiedMethodsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000024+01:00') #(#(#RGMethodDefinition #(#'RBEquivalentSuperclassMethodsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.465000001+01:00') #(#(#RGMethodDefinition #(#'RBBooleanPrecedenceRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000005+01:00') #(#(#RGMethodDefinition #(#'RBReturnsBooleanAndOtherRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000017+01:00') #(#(#RGMethodDefinition #(#'RBLongMethodsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000035+01:00') #(#(#RGMethodDefinition #(#'RBCascadedNextPutAllsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000007+01:00') #(#(#RGMethodDefinition #(#'RBReturnsIfTrueRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000002+01:00') #(#(#RGMethodDefinition #(#'RBInstVarInSubclassesRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.46000004+01:00') #(#(#RGMethodDefinition #(#'RBSearchingLiteralRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000062+01:00') #(#(#RGMethodDefinition #(#'RBContainsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000016+01:00') #(#(#RGMethodDefinition #(#'RBAssignmentInIfTrueRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000012+01:00') #(#(#RGMethodDefinition #(#'RBTransformationRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000057+01:00') #(#(#RGMethodDefinition #(#'RBJustSendsSuperRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000015+01:00') #(#(#RGMethodDefinition #(#'RBSentNotImplementedRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000045+01:00') #(#(#RGMethodDefinition #(#'RBAssignmentWithoutEffectRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000025+01:00') #(#(#RGMethodDefinition #(#'RBExcessiveVariablesRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000016+01:00') #(#(#RGMethodDefinition #(#'RBGuardingClauseRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000043+01:00') #(#(#RGMethodDefinition #(#'RBVariableReferencedOnceRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000024+01:00') #(#(#RGMethodDefinition #(#'RBMethodSourceContainsLinefeedsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.46000005+01:00') #(#(#RGMethodDefinition #(#'RBExtraBlockRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000012+01:00') #(#(#RGMethodDefinition #(#'RBGuardClauseRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000009+01:00') #(#(#RGMethodDefinition #(#'RBExcessiveMethodsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000026+01:00') #(#(#RGMethodDefinition #(#'RBUnpackagedCodeRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000054+01:00') #(#(#RGMethodDefinition #(#'RBUnwindBlocksRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000003+01:00') #(#(#RGMethodDefinition #(#'RBUndeclaredReferenceRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000041+01:00') #(#(#RGMethodDefinition #(#'RBMissingSubclassResponsibilityRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000055+01:00') #(#(#RGMethodDefinition #(#'RBSubclassResponsibilityNotDefinedRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000014+01:00') #(#(#RGMethodDefinition #(#'RBParseTreeLintRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000022+01:00') #(#(#RGMethodDefinition #(#'RBEqualsTrueRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000059+01:00') #(#(#RGMethodDefinition #(#'RBLiteralArrayCharactersRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000063+01:00') #(#(#RGMethodDefinition #(#'RBTempVarOverridesInstVarRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.46000003+01:00') #(#(#RGMethodDefinition #(#'RBPrecedenceRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000064+01:00') #(#(#RGMethodDefinition #(#'RBSizeCheckRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.465+01:00') #(#(#RGMethodDefinition #(#'RBNotEliminationRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000025+01:00') #(#(#RGMethodDefinition #(#'RBUnconditionalRecursionRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000017+01:00') #(#(#RGMethodDefinition #(#'RBTemporaryVariableCapitalizationRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.45800002+01:00') #(#(#RGMethodDefinition #(#'RBAtIfAbsentRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000049+01:00') #(#(#RGMethodDefinition #(#'RBSendsDifferentSuperRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000065+01:00') #(#(#RGMethodDefinition #(#'RBEmptyExceptionHandlerRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463+01:00') #(#(#RGMethodDefinition #(#'RBCollectSelectNotUsedRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.45800003+01:00') #(#(#RGMethodDefinition #(#'RBToDoWithIncrementRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.46000006+01:00') #(#(#RGMethodDefinition #(#'RBIfTrueBlocksRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000061+01:00') #(#(#RGMethodDefinition #(#'RBAddRemoveDependentsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000031+01:00') #(#(#RGMethodDefinition #(#'RBTempsReadBeforeWrittenRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000027+01:00') #(#(#RGMethodDefinition #(#'RBExcessiveInheritanceRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000006+01:00') #(#(#RGMethodDefinition #(#'RBModifiesCollectionRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000023+01:00') #(#(#RGMethodDefinition #(#'RBBadMessageRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000001+01:00') #(#(#RGMethodDefinition #(#'RBNoClassCommentRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000013+01:00') #(#(#RGMethodDefinition #(#'RBUnnecessaryAssignmentRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000015+01:00') #(#(#RGMethodDefinition #(#'RBCollectionProtocolRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000028+01:00') #(#(#RGMethodDefinition #(#'RBStringConcatenationRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000008+01:00') #(#(#RGMethodDefinition #(#'RBThreeElementPointRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000026+01:00') #(#(#RGMethodDefinition #(#'RBTranslateLiteralsInMenusRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000013+01:00') #(#(#RGMethodDefinition #(#'RBOverridesSpecialMessageRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000031+01:00') #(#(#RGMethodDefinition #(#'RBToDoRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000037+01:00') #(#(#RGMethodDefinition #(#'RBSuperSendsNewRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000039+01:00') #(#(#RGMethodDefinition #(#'RBClassNotReferencedRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000008+01:00') #(#(#RGMethodDefinition #(#'RBOnlyReadOrWrittenTemporaryRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000058+01:00') #(#(#RGMethodDefinition #(#'RBYourselfNotUsedRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000015+01:00') #(#(#RGMethodDefinition #(#'RBUnreferencedVariablesRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000046+01:00') #(#(#RGMethodDefinition #(#'RBAssignmentInBlockRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.46+01:00') #(#(#RGMethodDefinition #(#'RBReturnInEnsureRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000018+01:00') #(#(#RGMethodDefinition #(#'RBAllAnyNoneSatisfyRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000021+01:00') #(#(#RGMethodDefinition #(#'RBIfTrueReturnsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000044+01:00') #(#(#RGMethodDefinition #(#'RBUsesTrueRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000012+01:00') #(#(#RGMethodDefinition #(#'RBMethodHasNoTimeStampRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000004+01:00') #(#(#RGMethodDefinition #(#'RBImplementedNotSentRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000006+01:00') #(#(#RGMethodDefinition #(#'RBRefersToClassRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.46000001+01:00') #(#(#RGMethodDefinition #(#'RBCompositeLintRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000003+01:00') #(#(#RGMethodDefinition #(#'RBInstanceVariableCapitalizationRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000032+01:00') #(#(#RGMethodDefinition #(#'RBClassNameInSelectorRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000011+01:00') #(#(#RGMethodDefinition #(#'RBMissingTranslationsInMenusRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000003+01:00') #(#(#RGMethodDefinition #(#'RBBasicLintRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000004+01:00') #(#(#RGMethodDefinition #(#'RBFileBlocksRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.46000002+01:00') #(#(#RGMethodDefinition #(#'RBClassVariableCapitalizationRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000008+01:00') #(#(#RGMethodDefinition #(#'RBBetweenAndRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000002+01:00') #(#(#RGMethodDefinition #(#'RBSendsDeprecatedMethodToGlobalRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000038+01:00') #(#(#RGMethodDefinition #(#'RBCollectionMessagesToExternalObjectRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.46300001+01:00') #(#(#RGMethodDefinition #(#'RBCollectionCopyEmptyRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000014+01:00') #(#(#RGMethodDefinition #(#'RBUnoptimizedToDoRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000027+01:00') #(#(#RGMethodDefinition #(#'RBInconsistentMethodClassificationRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000021+01:00') #(#(#RGMethodDefinition #(#'RBLiteralArrayContainsSuspiciousTrueFalseOrNilRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000019+01:00') #(#(#RGMethodDefinition #(#'RBFloatEqualityComparisonRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000023+01:00') #(#(#RGMethodDefinition #(#'RBLiteralArrayContainsCommaRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000022+01:00') #(#(#RGMethodDefinition #(#'RBUnderscoreAssignmentRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000018+01:00') #(#(#RGMethodDefinition #(#'RBMissingYourselfRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000029+01:00') #(#(#RGMethodDefinition #(#'RBWhileTrueRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.45800001+01:00') #(#(#RGMethodDefinition #(#'RBLawOfDemeterRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000005+01:00') #(#(#RGMethodDefinition #(#'RBToDoCollectRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000034+01:00') #(#(#RGMethodDefinition #(#'RBAsOrderedCollectionNotNeededRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000017+01:00') #(#(#RGMethodDefinition #(#'RBMethodModifierOverrideRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000047+01:00') #(#(#RGMethodDefinition #(#'RBUtilityMethodsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000052+01:00') #(#(#RGMethodDefinition #(#'RBSuperSendsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000056+01:00') #(#(#RGMethodDefinition #(#'RBEqualNilRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000042+01:00') #(#(#RGMethodDefinition #(#'RBConsistencyCheckRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000011+01:00') #(#(#RGMethodDefinition #(#'RBDefinesEqualNotHashRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000013+01:00') #(#(#RGMethodDefinition #(#'RBCodeCruftLeftInMethodsRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.458000007+01:00') #(#(#RGMethodDefinition #(#'RBUncommonMessageSendRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.460000033+01:00') #(#(#RGMethodDefinition #(#'RBClassInstVarNotInitializedRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000014+01:00') #(#(#RGMethodDefinition #(#'RBSendsUnknownMessageToGlobalRule class' #identifierMinorVersionNumber #true)) #'2013-02-01T15:29:56.463000016+01:00') )! !

!ManifestManifestCore class methodsFor: 'meta data' stamp: 'SimonAllier 2/1/2013 15:29'!
ruleImplementedNotSentRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#BuilderManifest #addTruePositive:of:version: #false)) #'2013-02-01T15:29:52.678000007+01:00') #(#(#RGMethodDefinition #(#SmalllintManifestChecker #isTruePositive:forRuleId:versionId: #false)) #'2013-02-01T15:29:52.678000011+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #removeManifestOf: #false)) #'2013-02-01T15:29:52.678000012+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #dateOfToDo:onRule:version: #false)) #'2013-02-01T15:29:52.678000013+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #dateOfTruePositive:onRule:version: #false)) #'2013-02-01T15:29:52.67800001+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #removeAllManifest #false)) #'2013-02-01T15:29:52.678000006+01:00') #(#(#RGMethodDefinition #(#'RBLintRule class' #uniqueIdentifierNumber #true)) #'2013-02-01T15:29:52.678000008+01:00') #(#(#RGMethodDefinition #(#BuilderManifest #installTruePositiveOf:version: #false)) #'2013-02-01T15:29:52.678000009+01:00') )! !
